# SciCraft - An interactive graphics front end to advanced data mining
# Copyright (C) 2002-2005 SciCraft Development Team
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# As a special exception, SciCraft Development Team gives permission
# to link this program with  Qt non-commercial edition, and distribute
# the resulting executable, without including the source code for the
# Qt non-commercial edition in the source distribution.

import types

from System import Tools
from System.Data import Data

class S4Object(Data.Data):



    def __init__(self, name, data):
        if type(name) is not types.StringType:
            raise TypeError, "Attribute 'name' has to be a string. Recieved " + str(type(name))

        Data.Data.__init__(self, name, data)
        self.parent    = None 
        self.children  = []
        self.path      = [self]


        
    def getPath(self):
        return self.path


        
    def getChildren(self):
        return self.children


        
    def getParent(self):
        return self.parent



    def addChild(self, s4obj):
        if isinstance(s4obj, S4Object):
            for child in self.getChildren():
                if child is s4obj:
                    raise ValueError, "Tried to add a child already added."

            if s4obj is self.parent:
                raise ValueError, "Tried to add an object already set as parent to list of children."
            self.children.append(s4obj)
            s4obj.setParent(self)
        else:
            raise TypeError, "Tried to add a non S4Object as child."



    def setParent(self, parent):
        if isinstance(parent, S4Object):
            for x in self.children:
                if parent is x:
                    raise ValueError, "Tried to set an already added child as parent."

            self.parent = parent
            print "parent.path for parent", parent.getName(), ":", parent.getPath()
            self.path = Tools.assertList(parent.getPath()[0:])
            self.path.append(self)
            print "path for", self.getName(), "ble", self.getPath()

            if self not in self.parent.getChildren():
                self.parent.addChild(self)
        else:
            raise ValueError, "Parameter parent has to an instance of class S4Object"



