# SciCraft - An interactive graphics front end to advanced data mining
# Copyright (C) 2002-2005 SciCraft Development Team
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# As a special exception, SciCraft Development Team gives permission
# to link this program with  Qt non-commercial edition, and distribute
# the resulting executable, without including the source code for the
# Qt non-commercial edition in the source distribution.

import re

class VardescEscaper:

    def __init__( self ):
        self.specialChrs = ["$", "@", "(", ")", "[", "]", ".", ","]

    def escapeVardesc( self, varDesc ):
        parts = []
        index = -1
        lastHit = 0
        for chr in varDesc:
            index += 1
            if chr in self.specialChrs:
                if lastHit != (index +1):
                    parts.append(varDesc[lastHit:index])
                parts.append(chr)
                lastHit = index +1
        parts.append(varDesc[lastHit:])
        for i in xrange(len(parts)):
            parts[i] = self.__escape(parts[i])
        assembled = ''.join(parts)
        return assembled


    def __escape( self, str ):
        if str in self.specialChrs: 
            return str
        strEs = re.escape(str)
        if strEs != str:
            strEs = '"' + strEs + '"'
        return strEs

#t = VardescEscaper()
#a = t.escapeVardesc('attributes(attributes(swirl)$maGnames)$maInfo$"ID"$class$test[[4]]')
#print a

#t.escapeVardesc("attributes(attributes(attributes(swirl)$maGnames)$maInfo)$\"ID\"")
