# SciCraft - An interactive graphics front end to advanced data mining
# Copyright (C) 2002-2005 SciCraft Development Team
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# As a special exception, SciCraft Development Team gives permission
# to link this program with  Qt non-commercial edition, and distribute
# the resulting executable, without including the source code for the
# Qt non-commercial edition in the source distribution.


class Comment:
    def __init__(self,parent):
        self.parent = parent
        #self.default = ""
        self.width = 0
        self.height = 0

    def setDefault(self,default):
        """
        Params:
               - default : String - The value to be set to the parameter object.
        Sets the value of the parameter.
        """
 
        self.parent.value = str(default)

    def getDefault(self):
        """
        Return:
               - List[String] - List containing all the values that this parameter has set.
        """
        
        return self.parent.value

    def setHeight(self,height):
        """
        Params:
               - height : Integer - The height of the visualisation of the comment field.
        """
        
        self.height = height

    def getHeight(self):
        """
        Return:
               - Integer - The height of the visualisation of the comment field.
        """
        
        return self.height

    def setWidth(self,width):
        """
        Params:
               - width : Integer - The width of the visualisation of the comment field.
        """
        
        self.width = width

    def getWidth(self):
        """
        Return:
               - Integer - The width of the visualisation of the comment field.
               """

        return self.width

    def toXML(self):
        """
        Return:
               - List[String] - List of lines containg XML instance of this instance
        Makes XML-code of this object      """

        returnlist = []
        height = self.getHeight()
        width = self.getWidth()
        size = ""
        if height and width:
            size = " width=\"" + str(width) + "\" height=\"" + str(height) + "\""
        default = self.getDefault()
        if default:
            returnlist.append("<comment" + size + ">" + str(default) + "</comment>")
        else:
            returnlist.append("<comment" + size + "\/>")
        return returnlist
