function [FreQSpec,AC,FullComPlexSpectrum] = FFT1D_rows(X)
% [FreQSpec,AC,FullComPlexSpetrum] = FFT1D_rows(X)
% Performs 1D Fourier transform of each row in X. 
%
% INPUT VARIABLE
%
% X                   = input data matrix X to be FFT'ed
%
% OUTPUT VARIABLES
%
% FreQSpec            = Matrix:Frequency spectrum of each row in X
% AC                  = Vector:AC component of each row
% FullComPlexSpetrum  = Matrix: Raw outputs from Octave fft(x)
%                       routine. This is a complex matrix
%
% Copyright (C), B.K. Alsberg, bka@phys.chem.ntnu.no
% Last update: 25/6-2004
%

[n,m] = size(X);

for i = 1:n
  [FreQSpec(i,:),AC(i,1),FullComPlexSpectrum(i,:)] = ...
      FourierTransform1D(X(i,:));
end;



