function [FreQSpec,AC,FullComPlexSpetrum] = FourierTransform1D(x)
% [FreQSpec,AC,FullComPlexSpetrum] = FourierTransform1D(x)
% Performs 1D Fourier transform of x. 
%
% INPUT VARIABLE
%
% x                   = input vector to be FFT'ed
%
% OUTPUT VARIABLES
%
% FreQSpec            = Frequency spectrum of input signal x
%                       this vector is approx. half length of x
% AC                  = AC component of x (i.e. frist element of fft(x))
% FullComPlexSpetrum  = the raw output vector from Octave fft(x)
%                       routine. This is a complex vector
%
% Copyright (C), B.K. Alsberg, bka@phys.chem.ntnu.no
% Last update: 25/6-2004
%


n = length(x);
ns = round((n-1)/2);
f = fft(x);
FullComPlexSpetrum = f;
v = abs(f);
AC = v(1);
vv = v(2:end);
FreQSpec = vv(1:ns);


