function [Xc,Yc,meanX,meanY] = centerXY(X,Y)
%CENTERXY.M
%mean centering of two matrices,X and Y 
%
%input:		X,Y - data 
%
%output: 	Xc,Yc - centered data
%		meanX,meanY - mean vectors of original data
%
%
% See: crossval, plsr

[m,n] = size(X);
[l,k] = size(Y);
if m~=l
  warning('X and Y does not have equal number of samples')
end

meanX = mean(X);
meanY = mean(Y);
Xc = X-ones(m,1)*meanX;
Yc = Y-ones(l,1)*meanY;
  
