function [T,v] = deflate(X,a)
%inflate-deflate functions
%A singular value decomposition on a matrix. The left eigenvectors are mult. with 
% the accomp. eigenvalues (T).
%
%file: deflate.m
%
%input:		X - matrix to deflate
%		a - optional (# factors if less than max(m,n))
%
%output: 	v - original row space 
%		T - scaled column space of decomposition (scores)
%
%

if nargin == 1 % use 
a = min(size(X));
end
[m,n] = size(X');
if m>n
  if a>n
    error(['Max number of factors to use is:  ' num2str(min(m,n))]);
  end
  [v,sig,u] = svd(X',0);
  T = u(:,1:a)*sig(1:a,1:a);
  %Xn = u(1:a)*sig(1:a,1:a)*v(:,1:a)';
else
  error('There is no need to deflate this matrix: nVars less than samples!');
end









