function [sub_models,full_model] = inflate(Vdef,full_model,sub_models,Aopt)
%INFLATE.M
%Function work together with deflate.m in matrix reconstruction.   
%NB! inflated vectors need to be rotated to full model
%
%input: 		Vdef - row space expansion from deflate (v)
%			sub_models - pert. plsr models
%			full_model - plsr model
%
%output:		sub_models - struct(W,P,B)
%			W - Weights of plsr decomp with above params
%			P - Xloadings
%			B - regression coefficients
%
%See also: DEFLATE
%
% todo: Rotate B's for all components ?? (or just for aOpt?)
% --using aMax as aOpt-- 

% inflate for all segmetents
nSegments = size(sub_models.W,3);
nVarX = size(Vdef,1);
nVarY = size(sub_models.B,2);
aMax = size(full_model.B,3);
W = zeros(nVarX, Aopt, nSegments);
P = zeros(nVarX, Aopt, nSegments);
B = zeros(nVarX,nVarY,aMax,nSegments);


for k = 1:nSegments
	W(:,:,k) = Vdef*sub_models.W(:,:,k);
	P(:,:,k) = Vdef*sub_models.P(:,:,k);
	
	for a = 1:aMax
	B(:,:,a,k) = Vdef*sub_models.B(:,:,a,k);
	end
end

%store
sub_models.W = W;
sub_models.P = P;
sub_models.B = B;
full_model.W = Vdef*full_model.W;
full_model.P = Vdef*full_model.P;

B=full_model.B;
full_model.B = zeros(nVarX,nVarY,aMax);

for a = 1:aMax
  full_model.B(:,:,a) = Vdef*B(:,:,a);%inflate all of B not just to aOpt EA
end
full_model.mx = (Vdef*full_model.mx')';

