function Bpval = jackknifeB(full_model,sub_models,aOpt,pls2)
%JACKKNIFEB.M
%function returns confidence estimates from jackknifing on the 
%regression params, b, from plsr sub models
%
%input:		full_model (B-(nXvar,nYvar,aMax))
%		sub_models (B-(nXvar,nYvar,aMax,nSegments))
%		aOpt - optimal number of factors
%
%output:	Ppval - pvalues for each x-variable
%
%example:	Bpval = jackknifeB(full_model,sub_models)
%
%

%  warning(num2str(pls2)) 
disp('here goes');
sub_models.B;
[nXvariables,nYvariables,aMax,nSegments] = size(sub_models.B);
df = nSegments-1;
pls2;
BCal = full_model.B(:,:);
if length(size(sub_models.B))==4 & pls2
	Bsub = squeeze(sub_models.B(:,:,aOpt,:));
	BCal = full_model.B(:,:,aOpt);
else

Bsub =reshape(sub_models.B(:,:,aOpt,:),nXvariables,nSegments);
BCal = full_model.B(:,:,aOpt);
end

	
varModels = zeros(size(BCal));
for i = 1:nSegments
  if  pls2 == 0
    varModels = varModels + (BCal - Bsub(:,i)).^2;
  else
    %warning(num2str(pls2))
    varModels = varModels + (BCal - Bsub(:,:,i)).^2;
  end %if
end %for
stdModels = sqrt(varModels*(df-1)/df);
if any(stdModels(:)==0)
  stdModels(find(stdModels==0)) = 900000000000000000000000;
  %If some input variables are constant the jackknifing will give
  %zero perturbation. This forces the constant variables to be insignificant
end

tStats = BCal./stdModels;
Bpval = 2*min(1-t_cdf(tStats,df),t_cdf(tStats,df)); %check if 2*.... is correct?

	    
