function [Wpval] = jackknifeW(data,sub_models,full_model,aMax,dfl)
%JAJKKNIFEW.M
%jack-knife confidence estimates on Xvariabel-weights, W, of PLSR .   
%
%input:		data - stuct(X,Y)
%		data.X - 
%		data.Y - regressors
%		sub_models - struct(T,W), perturbed models
%		T - scores from plsr (nSamples,aMax,nSegments)
%		W - xvariable weights from plsr (nVarsX,aMax,nSegments)
%		full_model - struct(T,W), calibration model
%		T - scores from plsr (nSamples,aMax)
%               W - xvariable weights from plsr (nVarsX,aMax)
%		aMax - maximum of pc's to calculate
%		dfl - indicator flag (deflated data=1, original data=0)
%
%Output:	Wpval -significance test on W's (p-values)
%
%
%
%See also: CROSSVAL, PLSR, PROCRUST, INFLATE, DEFLATE
%
% -- aMax is really aOpt -- 

nVariablesX = size(data.X,2);
nSegments = size(sub_models.T,3);
Wk = sub_models.W(:,1:aMax,:);


for i = 1:nVariablesX
%	keyboard
  w = reshape(Wk(i,:,:),aMax,nSegments)'; %reshape ok
  [Wpval(i),Wtsq(i)] = hotelling_test_jk_matlab(w,zeros(aMax,1));
 
end


