function [sub_models] = rotateSub(sub_models,full_model)
%ROTATESUB.M
%Function returns the sub_models rotated to the full calibration model.
%The rotation is decided by procrustes rotation of the x-variables weights, W
%
%input:		sub_models - 
%		full_model -
%
%output:	sub_models - rotated 
%
%
%

% Rotate with all components or with 1:aOpt ??
% -- This function rotates based upon aMax --
nSegments = size(sub_models.W,3);

for k = 1:nSegments
	[sub_models.T(:,:,k),C] = procrust(full_model.T,sub_models.T(:,:,k));
	sub_models.P(:,:,k) =  sub_models.P(:,:,k)*C';
	sub_models.Q(:,:,k) = sub_models.Q(:,:,k)*C';
	sub_models.W(:,:,k) = sub_models.W(:,:,k)*C';
end	
